package org.processmining.pmind.algorithms.concept;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Set;

import org.processmining.pmind.models.DMNAttribute;

public class ActivityDataStore {

	private Set<DMNAttribute> attributes;
	private HashMap<DMNAttribute,ArrayList<String>> values = new HashMap<DMNAttribute,ArrayList<String>>();
	private HashMap<DMNAttribute,ArrayList<Integer>> traces = new HashMap<DMNAttribute,ArrayList<Integer>>();
	
	public ActivityDataStore(Set<DMNAttribute> att){
		this.attributes = att;
		for(DMNAttribute s: attributes){
			values.put(s, new ArrayList<String>());	
			traces.put(s, new ArrayList<Integer>());
		}
	}
	
	public void addDataElement(DMNAttribute att, String value, int trace){
		values.get(att).add(value);
		traces.get(att).add(trace);
	}
	
	public Set<DMNAttribute> getAttributes(){
		return attributes;
	}
	
//	public HashMap<DMNAttribute,ArrayList<String>> getSubset(Collection<Integer> traces){
//		
//	}
	
	public String getValueForAt(DMNAttribute att, int i){
		for(int j=0;j<traces.get(att).size();j++)
			if(traces.get(att).get(j)==i)
				return values.get(att).get(j);
		return "";
	}
	
}
