package org.processmining.pmind.algorithms.concept;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import org.processmining.pmind.models.DMNActivityAttributePair;
import org.processmining.pmind.models.DMNEdge;
import org.processmining.pmind.models.DMNModel;

public class ModelComparison {
	
	DMNModel m1, m2;
	
	private Map<DMNActivityAttributePair,DMNActivityAttributePair> covered 
		= new HashMap<DMNActivityAttributePair,DMNActivityAttributePair>();
	private Set<DMNActivityAttributePair> missingInM = new HashSet<DMNActivityAttributePair>();
	private Set<DMNActivityAttributePair> missingInM2 = new HashSet<DMNActivityAttributePair>();
	private Set<DMNEdge> missingEdgesM1 = new HashSet<DMNEdge>();
	private Set<DMNEdge> missingEdgesM2 = new HashSet<DMNEdge>();
	
	private double score;
	private Map<DMNActivityAttributePair,String> replayResults = new HashMap<DMNActivityAttributePair,String>();
	
	private Set<ModelComparison> subModels = new HashSet<ModelComparison>();
	
	public ModelComparison(DMNModel m1, DMNModel m2, Map<DMNActivityAttributePair,DMNActivityAttributePair> c, 
			Set<DMNActivityAttributePair> mIM, Set<DMNActivityAttributePair> mIM2, Set<DMNEdge> me1, Set<DMNEdge> me2, double score){
		this.m1 = m1;
		this.m2 = m2;
		this.covered = c;
		this.missingInM = mIM;
		this.missingInM2 = mIM2;
		this.missingEdgesM1 = me1;
		this.missingEdgesM2 = me2;
		this.score = score;		
	}
	
	public DMNModel getModel1(){
		return m1;
	}

	public DMNModel getModel2(){
		return m2;
	}
	
	public Set<DMNActivityAttributePair> getMissingInM() {
		return missingInM;
	}

	public Set<DMNActivityAttributePair> getMissingInM2() {
		return missingInM2;
	}
	
	public Set<DMNEdge> getMissingEdgesM1() {
		return missingEdgesM1;
	}

	public Set<DMNEdge> getMissingEdgesM2() {
		return missingEdgesM2;
	}

	public Map<DMNActivityAttributePair,DMNActivityAttributePair> getCovered() {
		return covered;
	}
	
	public DMNActivityAttributePair getMatchedModel(DMNActivityAttributePair d) {
		return covered.get(d);
	}

	public double getScore(){
		return score;
	}
	
	public void addReplayResult(DMNActivityAttributePair d, String score){
		replayResults.put(d, score);
	}
	
	public String getReplayResult(DMNActivityAttributePair d){
		return replayResults.get(d);
	}
	
	public Map<DMNActivityAttributePair, String> getReplayResults(){
		return replayResults;
	}
	
	public void addSubModels(Set<ModelComparison> ms){
		subModels.addAll(ms);
	}
	
	public void addSubModel(ModelComparison m){
		subModels.add(m);
	}
	
	public Set<ModelComparison> getSubModels(){
		return subModels;
	}

}
