package org.processmining.pmind.algorithms.concept;

import java.util.Collection;

import org.processmining.pmind.models.DMNActivity;
import org.processmining.pmind.models.DMNAttribute;

public class TrainedModel {
	
	private DMNActivity a;
	private DMNAttribute at;
	private Collection<Integer> traces;
	
	private Double sup = 0.0;
	
	public TrainedModel(DMNActivity a, DMNAttribute at, Collection<Integer> traces){
		this.a = a;
		this.at = at;
		this.traces = traces;
	}
	
	public void setSup(double sup){
		this.sup = sup;
	}
	
	public DMNActivity getAct(){
		return a;
	}
	
	public DMNAttribute getAt(){
		return at;
	}
	
	public Collection<Integer> getTraces(){
		return traces;
	}
	
	public double getSup(){
		return  sup;
	}
	
	public boolean equals(Object m){
		TrainedModel tm;
		if(m instanceof TrainedModel)
			tm = (TrainedModel) m;
		else
			return false;
		
		if(!a.equals(tm.getAct()))
			return false;
		if(!at.equals(tm.getAt()))
			return false;
		if(!traces.equals(tm.getTraces()))
			return false;
		
		return true;
	}
	
	
}
