package org.processmining.pmind.models;

import java.util.Set;

import org.processmining.models.graphbased.AttributeMap;
import org.processmining.plugins.graphviz.dot.Dot;

public class DMNDecisionActivity extends DMNActivity{

	private DMNAttribute attribute;
	private int shift;
	private Set<Integer> traces;
	
	public DMNDecisionActivity(DMNModel net, Dot d, Activity a, DMNAttribute at, int shift, Set<Integer> traces) {
		super(net, a);
		if(shift>0)
			getAttributeMap().put(AttributeMap.LABEL, activity.getName()+"->"+at+"("+shift+")");
		else
			getAttributeMap().put(AttributeMap.LABEL, activity.getName()+"->"+at);
		this.node = d.addNode(getLabel());
		
		setAttribute(at);
		setShift(shift);
		setTraces(traces);
	}

	public DMNAttribute getAttribute() {
		return attribute;
	}

	public void setAttribute(DMNAttribute attribute) {
		this.attribute = attribute;
	}

	public int getShift() {
		return shift;
	}

	public void setShift(int shift) {
		this.shift = shift;
	}
	
	public boolean equals(Object o) {
		DMNDecisionActivity a = null;
		if(o instanceof DMNActivity){
			a = (DMNDecisionActivity) o;
			if(activity.equals(a.getActivity()) && getAttribute().equals(a.getAttribute()) && getShift()==a.getShift())
				return true;
		}
		return false;
	}

	public Set<Integer> getTraces() {
		return traces;
	}

	public void setTraces(Set<Integer> traces) {
		this.traces = traces;
	}
	
}
