package org.processmining.pmind.models;

import org.processmining.models.graphbased.directed.AbstractDirectedGraphEdge;
import org.processmining.plugins.graphviz.dot.Dot;
import org.processmining.plugins.graphviz.dot.DotEdge;

public class DMNEdge extends AbstractDirectedGraphEdge<DMNNode, DMNNode>{

	private int weight;
	private double corr;
	private DotEdge edge;
	
	public DMNEdge(DMNNode source, DMNNode target, Integer weight, double corr, Dot dot) {
		super(source, target);
		this.weight = weight;
		this.corr = corr;
		edge = dot.addEdge(source.getDotNode(), target.getDotNode());
		edge.setLabel(String.valueOf(weight)+","+String.valueOf(corr)); 
	}
	
	public int getWeight(){
		return weight;
	}
	
	public double getCorr(){
		return corr;
	}

	public DotEdge getDotEdge(){
		return edge;
	}
	
}
