package org.processmining.pmind.output;

import java.util.Collection;
import java.util.Set;

import org.processmining.pmind.algorithms.AbstractDMNMiner;
import org.processmining.pmind.algorithms.concept.TraceCluster;
import org.processmining.pmind.models.DMNModel;
import org.processmining.pmind.parameters.PMInDParameters;

public class PMInDOutput {

	private Collection<TraceCluster> traceClusters;
	private Set<DMNModel> models;
	private boolean perTrace;
	private AbstractDMNMiner miner;
	private PMInDParameters parameters;
	
	public PMInDOutput(AbstractDMNMiner miner, PMInDParameters parameters){
		this.traceClusters = miner.getTraceClusters();
		this.models = miner.getModels();
		this.perTrace = parameters.isPrintModels();
		this.miner = miner;
	}
	
	public Collection<TraceCluster> getTraceClusters(){
		return traceClusters;
	}
	
	public Set<DMNModel> getModels(){
		return models;
	}
	
	public boolean isPerTrace(){
		return perTrace;
	}
	
	public AbstractDMNMiner getMiner(){
		return miner;
	}
	
	public PMInDParameters getParameters(){
		return parameters;
	}
	
}
