package org.processmining.pmind.parameters;

import org.processmining.basicutils.parameters.impl.PluginParametersImpl;

public class PMInDParameters extends PluginParametersImpl {

	public enum MinerType{
		
	    shiftBased("Shift Based", "Uses shifts in activity-attribute pairs (AAP) to establish AAP partial orders"), 
	    nonShiftBased("Non-shift based", "Does not use shifts in activity-attribute pairs to establish AAP partial orders"), 
	    SOAP("SOAP-MInD", "Uses highest frequency to establish most likely AAP partial orders");

	    private String name;
	    private String description;

	    MinerType(String name, String description){
	    	this.name = name;
	    	this.description = description;
	    }

		public String toString(){
			return name+": "+description;
		}
		
	}
	
	private MinerType type = MinerType.shiftBased;
//	private MinerType type = MinerType.nonShiftBased;
//	private MinerType type = MinerType.SOAP;
	
	private boolean modelBased = true;
	
	// These integers are a score out of 100
	// Are converted to percentages later on	
	private Integer shiftRatio = 10;
	private Integer minSupport = 60;

	private Integer minTraceProportion= 10;
	private Integer minCorr= 10;
	private Integer minDev= 90;
	
	private Integer im = 20;
	
	private boolean printModels = false;
	
	public PMInDParameters() {
		super();
	}
	
	public void setIMSetting(Integer im){
		this.im = im;
	}
	
	public Integer getIMSetting(){
		return im;
	}
		
	public void setMinerType(MinerType type){
		this.type = type;
	}
	
	public MinerType getMinerType(){
		return type;
	}
	
	public void setMinSup(Integer minSup) {
		this.minSupport = minSup;
	}

	public Integer getMinSup() {
		return minSupport;
	}

	public void setShiftRatio(Integer shiftRatio) {
		this.shiftRatio = shiftRatio;
	}

	public void setMinCorrelation(Integer minCorr) {
		this.minCorr = minCorr;
	}
	
	public Integer getMinCorrelation() {
		return minCorr;
	}
	
	public Integer getMinDeviation() {
		return minDev;
	}
	
	public void setMinDeviation(Integer dev){
		this.minDev = dev;
	}
	
	public Integer getMinTraceProp() {
		return minTraceProportion;
	}
	
	public void setMinTraceProp(Integer minTrace) {
		this.minTraceProportion =minTrace;
	}
	
	public Integer getShiftRatio() {
		return shiftRatio;
	}
		
	public void setPrintModels(boolean pm){
		this.printModels = pm;
	}
	
	public boolean isPrintModels(){
		return printModels;
	}
	
	public String toString() {
		return "(" + getShiftRatio() + "," + getMinSup() + "," + isPrintModels() + ")";
	}

	public boolean isModelBased() {
		return modelBased;
	}

	public void setModelBased(boolean modelBased) {
		this.modelBased = modelBased;
	}
	
}
