package org.processmining.pmind.plugins;

import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;

import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XTrace;
import org.processmining.pmind.logs.EventLogOperations;
import org.processmining.pmind.models.DMNAttribute;

public class ConstructCorrelationsForEventAttributes {
	
	private static int minP = 0;
	
	public static void main(String[] args) throws Exception {
		// Load event log
		XLog log = EventLogOperations.loadEventLog("C:/Users/johan/Desktop/17Mini30.xes");
		log = EventLogOperations
				.loadEventLog("C:/Users/johan/Desktop/trace.mxml");
		
		// Add position information to the attributes (#occurrence in trace)
		EventLogOperations.addAttributePositionInformationToLog(log, true, 0);
						
		HashMap<String, DMNAttribute> attributes = new HashMap<String, DMNAttribute>();
		
		minP = (int) (log.size()*0.1);
		
		int traceNo = 0;
		for(XTrace t: log){
			for(XEvent e: t){
				for(String attributeKey: e.getAttributes().keySet()){
					DMNAttribute a = null;
					if(!attributes.containsKey(attributeKey)){
						a = new DMNAttribute(attributeKey);
						attributes.put(attributeKey, a);
					}else
						a = attributes.get(attributeKey);
					a.addValueOfTrace(traceNo, e.getAttributes().get(attributeKey).toString());
				}
			}
			traceNo++;
		}		
		
		//Collection<Pair<String,String>> checkedPairs = new HashSet<Pair<String,String>>();
		
		Collection<DMNAttribute> toRemove = new HashSet<DMNAttribute>();
		
		double uniqueRatio = 0.5;
		double minCorr = 0.1;
		
//		// Filter attributes:
//		// Too many unique values:
//		for(String attribute: attributes.keySet()){
//			DMNAttribute a = attributes.get(attribute);
//			//System.out.println("Attribute: "+attribute+" "+a.getValues().size()+" vs "+a.getTraces().size());
//			if(a.getValues().size()>(a.getTraces().size()*uniqueRatio)){
//				toRemove.add(a);			
//				System.out.println("Too many unique values: "+a.toString());
//			}
//		}		
//		
//		// No high correlation with concept:name
//		DMNAttribute attribute = attributes.get("concept:name");
//		for (String attribute2 : attributes.keySet()) {			
//			if (!attribute.equals(attribute2) && !toRemove.contains(attribute2)) {
//				double autoCorr = calculateCorrelation(attribute, attributes.get(attribute2));
//				if(!(autoCorr>minCorr)){
//					toRemove.add(attributes.get(attribute2));
//					System.out.println("Not correlated: "+attribute2.toString());
//				}
//			}
//		}
//		
//		// Discretize?
//		
//		
//		// Remove obsolete attributes
//		for(XTrace t: log)
//			for(XEvent e: t)
//				for(DMNAttribute a: toRemove)
//					e.getAttributes().remove(a.toString());
		
		EventLogOperations.writeEventLog(log, "C:/Users/johan/Desktop/_log_trace.xes");		
		System.exit(0);
	}
	

}
