package org.processmining.pmind.plugins;

import org.deckfour.xes.model.XLog;
import org.processmining.pmind.algorithms.AbstractDMNMiner;
import org.processmining.pmind.algorithms.PMInDShiftBased;
import org.processmining.pmind.logs.EventLogOperations;
import org.processmining.pmind.models.DMNModel;
import org.processmining.pmind.parameters.PMInDParameters;

public class PMInDStandalone {
	

	public static void main(String[] args) throws Exception {		
		PMInDParameters param = new PMInDParameters();
		
		XLog log = EventLogOperations.loadEventLog("C:/Users/johan/Desktop/17Mini30.xes");
		//log = EventLogOperations.loadEventLog("C:/Users/johan/Desktop/BPI Challenge 2017.xes");
		log = EventLogOperations.loadEventLog("C:/Users/johan/Desktop/17Mini10.xes");
		
		AbstractDMNMiner miner = new PMInDShiftBased(log, param);
		
		long begin = System.currentTimeMillis();
		miner.mineDMNModels();
		long time = System.currentTimeMillis() - begin;
		
		int noModels = miner.getModels().size();
		int noNodes = 0;
		int noEdges = 0;
		int noTrained = 0;
		int depth = 0;
		
		for(DMNModel m: miner.getModels()){
			noNodes += m.getNodes().size();
			noEdges += m.getEdges().size();			
			noTrained += m.getTrainedModels().size();		
		}
		if(noModels>0){
			noNodes = noNodes/noModels;
			noEdges = noEdges/noModels;
			noTrained = noEdges/noModels;
		}
		StringBuilder sb = new StringBuilder();
		sb.append(time+","
				+noNodes+","+noEdges+","+noTrained+","+miner.getTraceClusters().size()+"\n");
		System.out.println(sb.toString());
	}
	
}
